# This file specifies the marker genes methods (and their parameters) which
# will be assessed.

# Read the overall config file.
config <- yaml::read_yaml(here::here("config.yaml"))

# For now we will start with {scran} (with default arguments) only.

# The methods to be run.
methods <- c("scran")

# Using expand_grid because it has nicer as.list behavior.
scran <- expand.grid(method = "scran",
                     test.type = c("t", "wilcox"),
                     pval.type = c("any", "all"))

method_pars <- scran

method_ids <- apply(method_pars, 1, function(x) paste0(x, collapse = "_"))

# We want each row to be a list.
method_pars <- apply(method_pars, 1, function(x) as.list(x))
names(method_pars) <- method_ids

# TODO: Use csv or stick to JSON?

# Write out the method ids to a (JSON) file.
write(jsonlite::toJSON(method_ids), config$method_ids_path)

# Construct the paths of the method id files.
# TODO: This could be made simpler...
method_paths <- here::here(config$method_pars_folder, method_ids)
method_paths <- paste0(method_paths, ".json")
names(method_paths) <- method_ids

# Write all the parameters of each method to file.
for (id in method_ids) {
  write(jsonlite::toJSON(method_pars[[id]], null = "null"), method_paths[[id]])
}
